#include <iostream>
#include <fstream>

#include "mm_image_fileinput.h"
#include "mm_image_qtoutput.h"
#include "mm_image_funcs.h"
#include "mm_property_image.h"


#include "mm_find_line.hh"
#include "mm_canny.h"
using namespace mimas;
using namespace std;

int main(int argc, char **argv)
{
  int retVal = 0;
  try{
    QApplication app( argc, argv );
  
    mm_image<unsigned char> edgeImage;
    mm_image<mm_rgba<unsigned char> > original;
  
    mm_canny<unsigned char> canny;
  
    //canny.setCannyLowThres(20);
    //canny.setCannyHighThres(91);
    canny.setCannyAutoThres(true); // default is true anyway
    canny.setCannyStdDev(1);

    std::ifstream file( argv[1], ios::binary ); //should send an exception if no filename is present
    //is it my job to do this or should it be embeded with ifstream or >> operator.
    
    file >> original;

    edgeImage = mm_image< unsigned char >( original );

    canny.canny(edgeImage);

    mm_image_qtoutput< unsigned char  > display( app );
    display << edgeImage << mimas::pause();

    mm_find_line<mm_image<unsigned char>::iterator > h(edgeImage.ul() + Dist2D(50,10),edgeImage.lr() + Dist2D(-10 ,0), atof(argv[2]) , atoi(argv[3]));
    
    h.exec();
  } catch (exception &e) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}

