#include "mm_integral_image.h"

mimas::mm_integral_image::mm_integral_image(mm_image<unsigned char> &image)
{
  integralImage.init(image.getWidth(), image.getHeight());      
  intermediateIntegralImage.init(image.getWidth(), image.getHeight());
  
  //we first do the sum along the columns
  //it_o for original image
  //it_i for intermediate 

  mimas::mm_image<unsigned char>::iterator it_o = image.ul();
  mimas::mm_image<int>::iterator it_i = intermediateIntegralImage.ul();
  for (;it_o.x < image.lr().x; it_o.x++, it_i.x++)
    {
      //we copy the first line as such
      *it_i = *it_o;
      //	  *it_f = *it_o;
	  
      //create an iterator for each column
      mimas::mm_image<unsigned char>::iterator it_oc(it_o);
      mimas::mm_image<int>::iterator it_ic(it_i);
	  
      for (it_oc.y++, it_ic.y++; it_oc.y < image.lr().y; it_oc.y++, it_ic.y++)
	{
	  *it_ic = *it_oc + it_ic[mimas::Dist2D(0, -1)]; 	    
	}
    }
      
  //Now the intermediate image we can calculate the integral image
  //doing the sum along the lines
  //it_f for final image
      
  it_i = intermediateIntegralImage.ul();
  mimas::mm_image<int>::iterator it_f = integralImage.ul();
      
  for (;it_i.y < intermediateIntegralImage.lr().y; it_f.y++, it_i.y++)
    {
      //we copy the first column as such
      *it_f = *it_i;

      //create an iterator for each line
      mimas::mm_image<int>::iterator it_il(it_i);
      mimas::mm_image<int>::iterator it_fl(it_f);
	  
      for (it_fl.x++, it_il.x++; it_il.x < intermediateIntegralImage.lr().x; it_il.x++, it_fl.x++)
	{
	  *it_fl = *it_il + it_fl[mimas::Dist2D(-1, 0)]; 	    
	}
    }
}
