#ifndef MM_INTEGRAL_IMAGE_H
#define MM_INTEGRAL_IMAGE_H

#include "mm_image.h"

/**
 *
 *
 *
 *
 *
 * Time-stamp: <2005-08-03 19:04:47 engmb>
 * Copyright (C) 2005 by Manuel Boissenin
 *
 * @author Manuel Boissenin
 * @date 28/07/2005
 * ***********************************************************************/

namespace mimas{

class mm_integral_image{
 public:

  inline int getPixel(const int i, const int j) const
    {
      return integralImage.getPixel(i,j); 
    }

  inline int getWidth(void) const
    {
      return integralImage.getWidth();
    }

  inline int getHeight(void) const
    {
      return integralImage.getHeight();
    }

  const boost::multi_array<int, 2> rawData() const
    {
      return integralImage.rawData();
    }
  
  mm_integral_image(mm_image<unsigned char> &image);

  /*
  ~mm_integral_image()
    {
      std::cerr<<"mm_integral_image destructor"<<std::endl;
    }
  */
 private:
  mm_image<int> integralImage;
  mm_image<int> intermediateIntegralImage;
};

}

#endif
