//
// Example usage of grey artistic filters
// Bala Amavasai (bala@amavasai.org)
//
//

// $Header: /cvs/mimas/examples/artistic/main.cc,v 1.7 2005/07/15 19:35:16 engjw Exp $


#include <fstream>
#include <iostream>
#include "mm_image.h"
#include "mm_image_fileinput.h"
#include "mm_image_qtoutput.h"
#include "mm_image_funcs.h"

using namespace mimas;
using namespace std;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {
    QApplication app( argc, argv );
    mm_image<int> imagein, imageout, tmp;
    mm_image_qtoutput<unsigned char> display( app );

    const char *fileName = "../images/stills/lena-512x512.pgm";
    ifstream file( fileName, ios::binary );
    MMERROR( file >> imagein, mm_exception, ,
             "Error loading file \"" << fileName << "\"." );

    display << imagein << mimas::pause();

    oilPainting(imagein,imageout,7);
    display << imageout << mimas::pause();

    display << focusEnhance( imagein ) << mimas::pause();

    display << featureEnhance( imagein ) << mimas::pause();

    display << emboss( imagein ) << mimas::pause();

    display << softenHeavy( imagein ) << mimas::pause();

    display << softenMedium( imagein ) << mimas::pause();

    display << softenLight( imagein ) << mimas::pause();
  } catch ( exception &e ) {
    cerr << "Error: " << e.what() << endl;
    retVal = 1;
  };

  return retVal;
}
