#ifndef __AUTOPGHWIDGET_H
#define __AUTOPGHWIDGET_H

#include <boost/shared_ptr.hpp>
#include <qwidget.h>
#include <list>
#include "mm_line.h"
#include "mm_object_instance_list.h"
#include "mm_pgh_2dobject.h"
#include "mm_pgh_scene.h"

class AutoPghWidget: public QWidget
{
  Q_OBJECT
 public:
  AutoPghWidget( QWidget *parent, const char *name = 0, WFlags f = 0 );
 protected:
  virtual void timerEvent( QTimerEvent * );
  virtual void paintEvent( QPaintEvent * );
  boost::shared_ptr< mimas::mm_pgh_2dobject > house;
  mimas::mm_pgh_scene camera_scene;
  boost::shared_ptr< std::list< boost::shared_ptr< mimas::mm_line > > > geom;
  boost::shared_ptr< mimas::mm_object_instance_list > houses;
};

#endif
