//
// Example usage of binary morphology tool
// Bala Amavasai (bala@amavasai.org)
//
// $Header: /cvs/mimas/examples/blob/main.cc,v 1.12 2004/12/09 23:27:18 engjw Exp $
//


#include <iostream>
#include <fstream>
#include "mm_image.h"
#include "mm_image_fileinput.h"
#include "mm_image_qtoutput.h"
#include "mm_binmorph_tool.h"

using namespace std;
using namespace mimas;

int	main(int argc, char **argv)
{
  int retVal = 0;
  try {
   QApplication app( argc, argv );
	mm_image<int> imagein, imagebin, imageeroded, imagedilated, imageedges, imageout;
	mm_binmorph_tool blob;
   mm_image_qtoutput< unsigned char > display( app );

   ifstream file( "../images/stills/jellybeans-256x256.pgm", ios::binary );
   file >> imagein;
   display << imagein << mimas::pause();

	// binarise image - note that imagebin only contains 0s and 1s!!!!
	blob.greyToBinaryOtsu(imagein, imagebin);

	// eroded and dilated versions of imagebin
	blob.erosion(imagebin,imageeroded);
   imageout = imageeroded;
	blob.normaliseToGrey(imageout);
   display << imageout << mimas::pause();

	blob.dilation(imagebin,imagedilated);
   imageout = imagedilated;
	blob.normaliseToGrey(imageout);
   display << imageout << mimas::pause();

	// morphological difference of two images
	blob.difference(imagedilated,imageeroded,imageedges);
   imageout = imageedges;
	blob.normaliseToGrey(imageout);
   display << imageout << mimas::pause();

	// distance map
	// blob.distanceTransform(imageedges,imageout);
	// blob.normaliseToGrey(imageout);
	// display(imageout);
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };

	return retVal;
}


