//
// stumeikle
// canny (with postprocessing) example
//


#include <iostream>
#include <fstream>
#include <cstdlib>
#include <vector>
#include "mm_image.h"
#include "mm_image_fileinput.h"
#include "mm_image_qtoutput.h"
#include "mm_image_funcs.h"
#include "mm_property_image.h"
#include "mm_edge_string_op.h"
#include "mm_canny_tool.h"

using namespace std;
using namespace mimas;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {
   QApplication app( argc, argv );
	mm_image<int> 		input;
	mm_canny_tool<int>		canny;
	mm_edge_string_ptr_list	edge_strings;
	mm_edgestring_image		eim;

   MMERROR( argc == 2, mm_exception, ,
            "Gimme an image file!" );

   ifstream file( argv[1], ios::binary );
   file >> input;

	//(1) first run canny to extract a set of mm_string_el strings
	mm_edge_string_op::useFastMode();
	edge_strings=canny.findEdgeStrings( input );

	//(2) then create an image to contain them for visualisation
	// eim.setOwnership(false);
	eim.init( input.getWidth(), input.getHeight());
	eim.addStrings( edge_strings );
   mm_image_qtoutput< mm_rgba< unsigned char > > display( app );
   display << eim << mimas::pause();

	//(3) delete the strings
	// mm_edge_string_ptr_list::iterator	sit;
	// for(sit=edge_strings.begin();sit!=edge_strings.end();++sit)
   // delete (*sit);
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
