#include <fstream>
#include <iostream>
#include "mm_colour_properties_tool.h"
#include "mm_image_fileinput.h"
#include "mm_image_qtoutput.h"

using namespace std;
using namespace mimas;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {
   QApplication app( argc, argv );
	mm_image< mm_rgba< double > > im;
	mm_colour_properties_tool< double > prop;
   mm_image_qtoutput< mm_rgba< unsigned char > > display( app );

	cout << "Original image" << endl;
   ifstream file( "../images/stills/peppers-512x512-colour.ppm",
                  std::ios::binary );
   file >> im;
   display << im << mimas::pause();

	cout << "Increase contrast" << endl;
	prop.contrast(im, 0.5);
   display << im << mimas::pause();
	
	cout << "Decrease brightness" << endl;
	prop.brightness(im, -0.3);
   display << im << mimas::pause();

	cout << "Increase saturation" << endl;
	prop.saturation(im, 1.2);
   display << im << mimas::pause();

	cout << "Set Blue, Green and Alpha channels to zero" << endl << endl;
	prop.setChannel(im,0,"BGA");
   display << im << mimas::pause();
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}

