//
// Filter by colour - brainstorming
// $Header: /cvs/mimas/examples/colourFilter/main.cc,v 1.11 2005/07/28 21:59:50 engmb Exp $
//


#include <iostream>
#include <fstream>
#include "mm_image.h"
#include "mm_image_fileinput.h"
#include "mm_image_qtoutput.h"

using namespace std;
using namespace mimas;



int main(int argc, char **argv)
{
  int retVal = 0;
  try {
   QApplication app( argc, argv );
   mm_image< unsigned char > someimage;
   mm_image< mm_rgba< unsigned char > > img;
   mm_image_qtoutput< unsigned char > display( app );
	// int i;

   const char *imagefile="../images/stills/baboon-512x512-colour.ppm";
   ifstream stream( imagefile, ios::binary );
   stream >> img;

	int redRef, greenRef, blueRef, redRange, blueRange, greenRange;

	// First filter
	redRef=250;
	greenRef=63;
	blueRef=15;
	redRange=30;
	greenRange=15;
	blueRange=8;

	someimage.init( img.getWidth(), img.getHeight() );


	for (int j=0; j<img.getHeight(); j++)
		for (int i=0; i<img.getWidth(); i++)
		{
			int r,g,b;
			r=img.pixel(i,j).getRed();
			g=img.pixel(i,j).getGreen();
			b=img.pixel(i,j).getBlue();

			if ((abs(r-redRef)<=redRange) && (abs(g-greenRef)<=greenRange) && (abs(b-blueRef)<=blueRange))
           someimage.setPixel(i,j,0);
			else
				someimage.setPixel(i,j,255);
		}

	display << someimage << mimas::pause();
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
