#include <exception>
#include <iostream>
//#include "mm_convert.h"
#include <mm_image.h>
#include <fstream>

#include "mm_image_fileinput.h"
#include "mm_image_qtoutput.h"
#include "mm_image_funcs.h"
#include "mm_property_image.h"
/**
* Test and demonstrate the trait conversion system
* and the mm_convert_image functions.
* (in two flavours)
*
*
* @author Manuel Boissenin
* @date 15/02/2005
*
* Time-stamp: <2005-02-18 19:49:26 engmb>
* Copyright (C) 2005 by Manuel Boissenin
*
 ***********************************************************************/

using namespace mimas;

int main(int argc, char** argv) {
  int retVal = 0;
  try{
    MMERROR( argc == 2, mm_exception, ,
             "Syntax: " << argv[0] << " <image-file>" );
    QApplication app( argc, argv );
    mm_image_qtoutput< mm_rgba<unsigned char>  > display( app );
    mm_image_qtoutput< unsigned char > display2( app );
    
    mm_image<mm_rgba<unsigned char> > colorImage;
    
    std::ifstream file( argv[1], std::ios::binary );
    MMERROR( file >> colorImage, mm_exception, ,
             "Error opening file '" << argv[1] << "'." );

    display << colorImage << mimas::pause();

    //return type has to be specified
    //grayImage = convert_image<unsigned char>(colorImage);
    
    mm_image< unsigned char > grayImage( colorImage );
    display2 << grayImage << mimas::pause();

    mm_image< float > doubleImage( grayImage );
    display2 << mm_image< unsigned char >( doubleImage ) << mimas::pause();
    display << mm_image< mm_rgba<unsigned char> >(grayImage) << mimas::pause();

  } catch (std::exception &e) {
    std::cerr << e.what() << std::endl;
    retVal = 1;
  };
  return retVal;
}
