//
// Example application using mm_canny
// Bala Amavasai <bala@amavasai.org>
//
// $Header: /cvs/mimas/examples/corner_tool/main.cc,v 1.7 2005/06/15 12:28:36 engjw Exp $
//


#include <iostream>
#include <fstream>
#include <vector>
#include "mm_image.h"
#include "mm_image_fileinput.h"
#include "mm_image_funcs.h"
#include "mm_image_qtoutput.h"
#include "mm_canny.h"
#include "mm_filter.h"
#include "mm_corner_tool.h"
#include "mm_prop.h"

using namespace std;
using namespace mimas;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {
   
   MMERROR( argc == 2, mm_exception, ,
            "Syntax: " << argv[0] << " <image-file>" );
   
   QApplication app( argc, argv );
	mm_image<int>	 	someimage;
	mm_corner_tool<int>	corner_op(0.1);
   mm_image_qtoutput< mm_rgba< unsigned char > > display( app );
   
   ifstream file( argv[1], ios::binary );
   MMERROR( file >> someimage, mm_exception, ,
            "Error loading file \"" << argv[1] << "\"." );

   mm_corner_image cim;
   corner_op.filterImage(someimage, cim);
   displayWithOverlay( display, someimage, cim ); display << mimas::pause();
   
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}


