//
// Example application of despeckling
// NOTE: The original image (not the edge map) is despeckled
//
// Bala Amavasai <bala@amavasai.org>
//
// $Header: /cvs/mimas/examples/despeckle/main.cc,v 1.9 2005/03/03 15:53:54 engjw Exp $
//

#include <iostream>
#include <fstream>
#include "mm_image.h"
#include "mm_image_fileinput.h"
#include "mm_image_qtoutput.h"
#include "mm_image_funcs.h"
#include "mm_canny.h"

using namespace std; 
using namespace mimas;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {
    QApplication app( argc, argv );
    mm_image<int> image,tempimage;
    mm_canny<int> canny;
    mm_image_qtoutput< unsigned char > display( app );
    int count;

    cerr << "NOTE: The original image (not the edge map) is despeckled"
	 << endl;

    ifstream file( "../images/stills/baboon-512x512-colour.ppm", ios::binary );
    file >> image;

    // Do edge detection just to see effects of despeckling
    // on edges
    canny.setCannyAutoThres(false);
    canny.setCannyStdDev(0.5);
    canny.setCannyLowThres(20);
    canny.setCannyHighThres(91);

    for (count=0; count<10; count++)
      {
	tempimage = image;
	canny.canny(tempimage);
	display << tempimage << mimas::pause();

	// despeckle thrice in every loop
	for (int t=0; t<3; t++)
	  despeckleMedian(image);
      }
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
