#ifndef MM_TRIANGULARIZATION
#define MM_TRIANGULARIZATION

#include <iostream>
#include "mm_image_colour.h"
#include "mm_colour_properties_tool.h"
//#include "mm_gnuplot.h"
#include <fstream>

std::ofstream  gnuplotFile("depth.gp");

extern  MM_Global       *mm;


class mm_triangularization : public virtual mm_object{
 private:
  double baseline;
  double focal;
  mm_image_colour<float> &disparity_map;
  std::string depth_image_name;
 public:
  mm_image<int> image;
  mm_image_colour<float> depth_map; 
  //mm_gnuplot depth;

  mm_triangularization(double baseline,double focal,mm_image_colour<float> &disparity_map,std::string depth_image_name)
    :baseline(baseline),focal(focal),disparity_map(disparity_map),
    depth_image_name(depth_image_name)
    {
      depth_map.init(disparity_map.getWidth(),disparity_map.getHeight());
      image.init(disparity_map.getWidth(),disparity_map.getHeight());
    }

  void calculateDistance(void)
    {
      double factor = baseline * focal;
      mm_colour_properties_tool<float> tool;

      for (int i = 0; i < disparity_map.getWidth(); i++)
	for (int j = 0; j < disparity_map.getHeight(); j++)
	  {
	    if(disparity_map.isGrey(i,j))
	      {
		if(disparity_map.getPixelGreen(i,j) != 0)
		  {

		    float disparity = disparity_map.getPixelRed(i,j);
		    float distance = factor/disparity;
		    depth_map.setPixel(i, j,distance);
		    image.setPixel(i,j,int(distance));
		    if(distance < 80000)
		    gnuplotFile<<i<<" "<<j<<" "<<distance<<std::endl;

		  }
		else
		  depth_map.setPixelColour(i,j,"blue");
	      }
	    else
	      depth_map.setPixelColour(i,j,"green");
	  }  

      tool.scaleGray(depth_map, 0, 255);
      depth_map.display();
      //depth.plotImageProfile(image);
      gnuplotFile.close();
    }
};

#endif

