#include <iostream>
#include <fstream>
#include "mm_image.h"
#include "mm_image_fileinput.h"
#include "mm_image_mplayeroutput.h"

using namespace std;
using namespace mimas;

/**
 * Example usage of the mplayer output
 * Note that you need mplayer installed.
 * @author Bala Amavasai (bala@amavasai.org)
 * @date Tue May 18 14:55:46 BST 2004
 * $Header: /cvs/mimas/examples/display/main.cc,v 1.7 2005/04/27 18:04:11 engjw Exp $
 */

int main(void)
{
  int retVal = 0;

  try {

	mm_image< mm_rgba< unsigned char > > img[2];

   ifstream stu0File( "../images/sequences/stuart/stu0.ppm", ios::binary );
   stu0File >> img[0];
   ifstream stu1File( "../images/sequences/stuart/stu1.ppm", ios::binary );
   stu1File >> img[1];

	mm_image_mplayeroutput< mm_rgba< unsigned char > > disp
     ( img[0].getWidth(), img[0].getHeight() );
   
	// open a display that will stream to an MPEG4 avi file. This 
	// requires the yet to be released MPlayer 1.0 to be installed.
	// But see code if you want to use it:
	//disp.open(img[0].getWidth(),img[0].getHeight(), "output.avi");

	for (int a=0; a<40; a++)
     disp << img[ a % 2 ];

  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };

  return retVal;
}



