//
// Example application using mm_canny
// Bala Amavasai <bala@amavasai.org>
//
// $Header: /cvs/mimas/examples/edgeCanny/main.cc,v 1.10 2005/07/28 21:59:02 engmb Exp $
//


#include <iostream>
#include <fstream>
#include "mm_image_fileinput.h"
#include "mm_image_fileoutput.h"
#include "mm_image_qtoutput.h"
#include "mm_canny.h"
#include "mm_exception.h"

using namespace std; 
using namespace mimas;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {
    MMERROR( argc == 6, mm_exception, ,
	     "Syntax: " << argv[0] << " image-filename image-output-filename lowThreshold HighThreshold StdDev" );
    QApplication app( argc, argv );
    mm_image<int> someimage;
    mm_canny<int> canny;
    mm_image_qtoutput< unsigned char > display( app );

    canny.setCannyLowThres(atoi(argv[3]));
    canny.setCannyHighThres(atoi(argv[4]));
    canny.setCannyAutoThres(false); // default is true anyway
    canny.setCannyStdDev(atof(argv[5]));


    ifstream file( argv[1], ios::binary );

    file >> someimage;
    canny.canny(someimage);

    ofstream ofile(argv[2], ios::binary);
    ofile<< someimage;
   
    display << someimage << mimas::pause();
    
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
