//
// Example usage of edge detectors
// Bala Amavasai (bala@amavasai.org)
//
// $Header: /cvs/mimas/examples/edgeFilters/main.cc,v 1.10 2005/07/22 22:33:34 engjw Exp $
//


#include <iostream>
#include <fstream>
#include "mm_image.h"
#include "mm_image_fileinput.h"
#include "mm_image_qtoutput.h"
#include "mm_image_funcs.h"

using namespace std; 
using namespace mimas;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {
    QApplication app( argc, argv );
    mm_image<double> imagein, imageout;
    mm_image_qtoutput< unsigned char > display( app );

    ifstream file( "../images/stills/lena-512x512.pgm", ios::binary );
    file >> imagein;

    cerr << "Sobel edge detection" << endl;
    imageout = normalise( edgeSobel( imagein ), 0.0, 255.0 );
    display << imageout << mimas::pause();

    cerr << "  thresholded at 31.0" << endl;
    display << bilevel( imageout, 31.0, 0.0, 255.0 ) << mimas::pause();

    cerr << "Laplacian edge detection" << endl;
    display << normalise( edgeLaplacian( imagein ), 0.0, 255.0 )
            << mimas::pause();

    cerr << "Laplacian of Gaussian (LoG) edge detection - note to author: fix zero-crossings" << endl;
    display << normalise( edgeLoG( imagein ), 0.0, 255.0 ) << mimas::pause();
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
