//
// Histogram equalisation example
// Bala Amavasai <bala@amavasai.org>
//
// $Header: /cvs/mimas/examples/equalise/main.cc,v 1.7 2004/12/06 18:35:24 engjw Exp $
//

#include <iostream>
#include <fstream>
#include "mm_image.h"
#include "mm_image_fileinput.h"
#include "mm_image_qtoutput.h"
#include "mm_image_funcs.h"

using namespace std; 
using namespace mimas;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {
    QApplication app( argc, argv );
    mm_image<int> someimage;
    mm_image_qtoutput< unsigned char > display( app );

    ifstream file( "../images/stills/lena-512x512.pgm", ios::binary );
    file >> someimage;
    display << someimage << mimas::pause();

    equalise(someimage);
    display << someimage << mimas::pause();
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
