//
// stumeikle
// canny (with postprocessing) example
//

#include <fstream>
#include <iostream>
#include <vector>
#include "mm_image.h"
#include "mm_image_fileinput.h"
#include "mm_image_mesaoutput.h"
#include "mm_rgba.h"
#include "mm_property_image.h"
#include "mm_gauss.h"

using namespace std;
using namespace mimas;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {

    MMERROR( argc == 2, mm_exception, ,
             "Syntax: " << argv[0] << " <image-file>" );

    mm_image< unsigned char > input;
    mm_x11_display_ptr display( new mm_x11_display );
    mm_image_mesaoutput< unsigned char > window( display );

    
    ifstream file( argv[1], ios::binary );
    MMERROR( file >> input, mm_exception, , "Error loading file \""
             << argv[1] << "\"." );

    window << input << mimas::delay( 3000 )
           << mm_image< unsigned char >( gaussian_blur< float >
                                         ( input, 10.0f, 4.0f / 256.0f ) )
           << mimas::wait( 3000 );

  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
