#include <mm_image.h>
#include <mm_gnuplot.h>

using namespace mimas;
using namespace std;

int main( int, char *[] )
{
  int retVal = 0;
  try {
	mm_image<int> im;
	mm_gnuplot graph;

	graph << "set isosamples 40,40";
	graph << "set xrange[-3:3]";
	graph << "set yrange[-3:3]";
	graph << "set zrange[-2:2]";
	graph << "set hid; set nokey";


	for (int count=0; count<2; count++)
	{
		char s[255];

		for (double i=1; i<2; i+=0.05)
		{
		    sprintf(s,"splot cos(x*x*%e+y*y*%e)\n",i,i);
		    graph.command(s);
		}

		for (double i=2; i>1; i-=0.05)
		{
		    sprintf(s,"splot cos(x*x*%e+y*y*%e)\n",i,i);
		    graph.command(s);
		}

	}

	sleep(3);
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}

