#include <cassert>
#include <iostream>
#include <qdatetime.h>
#include "mm_image.h"
#include "mm_rgba.h"
#include "mm_image_gstreamerinput.h"
#include "mm_image_mesaoutput.h"
#include "mm_rgba.h"

using namespace boost;
using namespace mimas;
using namespace std;

int main( int argc, char *argv[] )
{
  int retVal = 0;

  try {

    MMERROR( argc == 3, mm_exception, ,
             "Syntax: " << argv[0] << " shmkey semkey" );

    mm_x11_display_ptr display( new mm_x11_display( ":0.0" ) );

    mm_image_gstreamerinput< mm_rgba< unsigned char > >
      gstreamer( atoi( argv[1] ), atoi( argv[2] ) );

    mm_image_mesaoutput< mm_rgba< unsigned char > > window( display );

    mm_image< mm_rgba< unsigned char > > image;

    while ( gstreamer >> image )
      window << image << mimas::delay( 50 );
    
  } catch ( exception &e ) {

    cerr << e.what() << endl;
    retVal = 1;

  };

  return retVal;
}
