//
// Example usages of the Haynes and Jain edge detector
// $Header: /cvs/mimas/examples/hj/main.cc,v 1.10 2005/07/15 19:35:38 engjw Exp $
//
// IMPORTANT NOTE:
// 	when calling edgeHaynesJain(image1,image2,outimage)
//  image1 = image at time t-1
//  image2 = image at time t
//

#include <iostream>
#include <fstream>
#include "mm_image.h"
#include "mm_image_fileinput.h"
#include "mm_image_qtoutput.h"
#include "mm_image_funcs.h"

using namespace std; 
using namespace mimas;

int	main(int argc, char **argv)
{
  int retVal = 0;
  try {
   QApplication app( argc, argv );

	mm_image<int> image1, image2, outimage;
   mm_image_qtoutput< unsigned char > display( app );

   ifstream file1( "grabbed0090.pgm", ios::binary );
   file1 >> image1;
   ifstream file2( "grabbed0091.pgm", ios::binary );
   file2 >> image2;

	outimage = edgeHaynesJain( image1, image2 );
	normaliseIt(outimage,0,255);
	bilevelIt( outimage, 5, 0, 255 );
   
	display << outimage << mimas::pause();

  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}


