#include <iostream>
#include <fstream>
#include "mm_image.h"
#include "mm_image_fileinput.h"
#include "mm_image_qtoutput.h"
#include "mm_image_funcs.h"
#include "mm_canny.h"

using namespace std;
using namespace mimas;

int	main(int argc, char **argv)
{
  int retVal = 0;
  try {
  QApplication app( argc, argv );
  mm_image_qtoutput< unsigned char > display( app );
  mm_image<int> imagein, imageout;
  mm_canny<int>	canny;

  ifstream file( "../images/stills/lena-512x512.pgm", ios::binary );
  file >> imagein;

  display << imagein << mimas::pause();

/*	for (int count=0; count<4; count++)
	{
		halfResolution(imagein);
		display(imagein);
	}
*/
	canny.canny(imagein);
   display << imagein << mimas::pause();

	// Note that halfResolutionEdgePyramid() assumes white (255) on black (0) images
	// unlike halfResolution() above
	for (int count=0; count<4; count++)
	{
		halfResolutionEdgePyramid(imagein);
		display << imagein << mimas::pause();
	}
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
