//
// Colour segmentation using the Spherical Coordinate Transform
// @author Bala Amavasai (bala@amavasai.org)
// @date Wed Mar 16 19:15:58 GMT 2005
// $Header: /cvs/mimas/examples/segmentsct/main.cc,v 1.1 2005/03/16 19:08:51 bpa Exp $
//

#include <fstream>
#include <iostream>
#include <qapplication.h>
#include "mm_segment_sct_tool.h"
#include "mm_image_fileinput.h"
#include "mm_image_fileoutput.h"
#include "mm_image_qtoutput.h"
#include "mm_rgba.h"

using namespace mimas;
using namespace std;

int main(int argc, char **argv)
{
	int retVal = 0;
	try {
		QApplication app( argc, argv );
		mm_segment_sct_tool scttool;

		MMERROR( argc >= 4, mm_exception, ,
				"Please see the README file for details of how to run this app" );

		
		// load in the image that contains sample colours
		mm_image< mm_rgba< unsigned char > > img;
		ifstream imFile( argv[1], ios::binary ); imFile >> img;

		// split angles
		scttool.setSplitA(atoi(argv[2]));
        scttool.setSplitB(atoi(argv[3]));


		// segment the image
		mm_image< mm_rgba< unsigned char > > imgout;
		scttool.segment(img,imgout);

		mm_image_qtoutput< mm_rgba< unsigned char > > display( app );
		display << imgout << mimas::pause();
		
	} catch ( exception &e ) {
		cerr << e.what() << endl;
		retVal = 1;
	};
	return retVal;
}
