//
// Example application for template based background subtraction
// $Header: /cvs/mimas/examples/subtractbg/main.cc,v 1.7 2004/12/06 18:35:24 engjw Exp $
//

#include <iostream>
#include <fstream>
#include "mm_image.h"
#include "mm_image_fileinput.h"
#include "mm_image_qtoutput.h"
#include "mm_bg_subtract.h"

using namespace std; 
using namespace mimas;

int	main(int argc, char **argv)
{
  int retVal = 0;
  try {
   QApplication app( argc, argv );
   mm_image_qtoutput< unsigned char > display( app );
	mm_image<int> someimage;
	mm_bg_subtract<int> bgs;
	// int i;
	
	// load image
   
   ifstream file( "video2_076.pgm", ios::binary );
   file >> someimage;
	//readFromFile(someimage,"snap-sssa.pgm");
	
	// extract template from some area in image
	bgs.createTemplate(someimage,243,82,249,88);
	//bgs.createTemplate(someimage,328,143,332,147);

	// subtract background
	bgs.removeBackground(someimage);

	//display image
   display << someimage << mimas::pause();
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
