#include <fstream>
#include <iostream>
#include <cstdlib>
#include "mm_image.h"
#include "mm_image_fileinput.h"
#include "mm_image_funcs.h"
#include "mm_image_qtoutput.h"

using namespace std; 
using namespace mimas;

int	main(int argc, char **argv)
{
  int retVal = 0;
  try {
	QApplication app( argc, argv );
	mm_image_qtoutput< unsigned char > display( app );
	
 	MMERROR( argc == 3, mm_exception, ,
            "Syntax : " << argv[0] << " pgm-input-image threshold" );
	
	mm_image< unsigned char > in_image;
	ifstream infile( argv[1], ios::binary );
	MMERROR( infile >> in_image, mm_exception, ,
            "Error loading image \"" << argv[1] << "\"." );

   unsigned char thresh = (unsigned char)atoi(argv[2]);

	display << in_image << mimas::delay( 2000 )
           << bilevel( in_image, thresh,
                       (unsigned char)0, (unsigned char)255 )
           << mimas::pause();

  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
