//
// angle routines and classes
// stuart meikle Wed Mar  8 15:45:13 2000
//

// beats messing around with angle calcs all the time!

#ifndef MM_ANGLE_H
#define MM_ANGLE_H

#include <cmath>

namespace mimas {
	
/** Angle class.
    Providing different operators for angles. The operators always will keep
    the value within \f$[-pi,pi)\f$.
    @author Stuart Meikle (stu@stumeikle.org)
    @date Wed Mar  8 15:45:13 2000 BST */
class	mm_angle
{
    private:
  /** The actual value.
      \f$-pi\le\mathrm{angle}<pi\f$ must hold. */
	double	angle;
	
	void	arcTan2( double	y, double x );
	void	normalize(void);
    public:

   /// Default constructor.
	mm_angle(void): angle(0) {}
   /** Constructor.
       @param aAngle Initial value. \f$\mathrm{value}\in[-pi,pi)\f$ must
       hold. */
  mm_angle( double aAngle ): angle(aAngle) {}

  mm_angle( double y, double x ) { arcTan2(y,x); }
	
	//this next is almost not an angle function , but it needs to live
	//within the namespace... DOESNT operate on 'this'

	//overload casting an angle to a double:
	operator double() const { return angle; }
	
	//basic ops overloading:
	mm_angle	operator+( mm_angle &a2 );
	mm_angle	operator-( mm_angle &a2 );
   mm_angle operator-(void) { return mm_angle( -angle ); }
	/* mm_angle        operator+=(const mm_angle& right);
	mm_angle        operator+=(const double& right); */
	mm_angle&        operator+=(const mm_angle& right);
	mm_angle&        operator+=(const double& right);
};
    
};

#endif
