//
// Cartesian template class
// by Bala Amavasai (and notes on the internet!)
// Tue Mar 13 18:04:22 GMT 2001 
//
// Wrote this to simplify task of creating STL lists of coordinate pairs.
// Don't know if it overlaps with Stuart's classes, but who cares.



#ifndef MM_CARTESIAN_H
#define MM_CARTESIAN_H


#include <iostream>

namespace mimas {


template <typename T>
class mm_Cartesian
{

	public:
      typedef std::ostream ostream;
		T x, y;
		
		mm_Cartesian()
		{
			x=0;
			y=0;
		}
		
		~mm_Cartesian(){}
		
		mm_Cartesian(const mm_Cartesian &copycoord)
		{
			x=copycoord.x;
			y=copycoord.y;
		}
		
		
		friend ostream &operator<<(ostream &output,
                                      const mm_Cartesian &outcoord)
		{
			output << outcoord.x << ' ' << outcoord.y;
			return output;
		}
		
		
		mm_Cartesian& operator=(const mm_Cartesian &rhs)
		{
			this->x=rhs.x;
			this->y=rhs.y;
			return *this;
		}
		
		int operator==(const mm_Cartesian &rhs) const
		{
			if (this->x!=rhs.x) return 0;
			if (this->y!=rhs.y) return 0;
			return 1;
		}
		
		int operator<(const mm_Cartesian &rhs) const
		{
			if (this->x < rhs.x) return 1;
			if (this->y < rhs.y) return 1;
			return 0;
		}
				
};

}
#endif
