//
// stuart meikle Tue Mar  7 16:12:54 2000
//


// today: i'll define the hough transform as being a double image. 
// in theory it could be any kind of image, so you might want to change
// this class to template<typename T> as some point



#ifndef MM_HOUGH_TRANSFORM_H
#define MM_HOUGH_TRANSFORM_H

#include <boost/numeric/ublas/vector.hpp>
#include <boost/shared_ptr.hpp>
#include "mm_object.h"
#include "mm_image.h"
#include "mm_line.h"
#include "mm_angle.h"

namespace mimas {
/** Hough transformation.
    Well I decided that HTs are a special kind of image (double in this case),
    with special operations such as plot Gaussian blob. Hence the HT class.
    This just inherits the image class. There are a few funcs to draw gaussian
    blobs and lines. If the line routine isn't working its my fault as I
    rewrote it. Acutally don't think there is one in tina... */
class	mm_hough_transform : public mm_image<double>
{
 private:
	int	calcGaussBoxSize( double sigma, double accuracy );

	//stumeikle Sun May 26 11:29:24 2002
	//adding some functionality to speed up plotting of points
   boost::shared_ptr< mm_image< double > > bell_curve;    

 public:
   typedef boost::numeric::ublas::vector< double > Vector;
   typedef boost::numeric::ublas::vector< int > IntVector;
	mm_hough_transform(void)
	{
	  //nothing to do. the underlying image still needs to be initialised in the
	  //usual manner
	  // bell_curve=NULL;
	}

	//hough transform like functions
	void	addGaussPoint( const IntVector &posn, double weight, double sigma, double precision );
	void	addGaussLine(  mm_line line, double weight, double sigma, double precision );
	void	addSlopedGaussLine( mm_line line, double weight, double sigma, double precision );
	bool	lineHitsPoint( const IntVector &point, mm_line line, double sigma, double precision );	
	void	makeAngleEntry( mm_angle a, double sigma, double prec );
	void	normalize(void);
	mm_angle getAngle( void );
	
	void	initFastGauss( double sigma, double precision );
	void	addGaussPointFast( const IntVector &posn );//, double weight );
	void	addGaussLineFast( mm_line line, double weight );
};

};

#endif

