// k-Nearest Neighbour
//
// Bala Amavsai (bala@amavasai.org)
// Fri May 25 12:48:48 BST 2001 
//

#ifndef MM_K_NEAREST_NEIGHBOUR_H
#define MM_K_NEAREST_NEIGHBOUR_H

#include <iostream>
#include <fstream>
#include <string>
#include <list>
#include <cstdlib>
#include <cmath>

namespace mimas {
class mm_knn
{
 public:
  typedef std::string string;
  typedef std::ifstream ifstream;
    protected:
    std::list<double> dataVector;
    std::list< std::list<double> > trainingInputSet;
    std::list< std::list<double> > trainingOutputSet;
	int inputVectorLength, outputVectorLength;
	
    public:
	//variables that can be changed by the user
	int numNeighbours;
	
	void loadTrainingSet(string fn);
	mm_knn()
	{
	    numNeighbours=5;
	}

	~mm_knn()
	{
	}
};

void mm_knn::loadTrainingSet(string fn)
{
    ifstream infile;
    string s;
    
    infile.open(fn.c_str());
//    assure(infile,fn.c_str());

    while(getline(infile,s))
    {
	int comment=s.find('#');
	if (comment!=(signed)string::npos) s=s.substr(0,comment);	
	if (s.length()==0) continue;

	int whitespace=s.find(' ');
	int tab=s.find('\t');

	if (whitespace==(signed)string::npos) whitespace=tab;
	if ((whitespace>tab) && (tab!=(signed)string::npos)) whitespace=tab;
	
	std::cerr << std::endl << "Whitespace " << whitespace << std::endl;

//	std::cerr << std::endl << "Space:tab"<< space << ":" << tab << ":" << std::endl;
	
	std::cerr << "line " << comment << ":" << s.length() << " " << s << std::endl;
    }	
    
    infile.close();
}

};

#endif







