#ifndef __MM_MULTI_ARRAY_OP_H
#define __MM_MULTI_ARRAY_OP_H

/** @page arrayOperators Operators for boost::multi_array.
    Implementations for element-wise operations on boost::multi_array are
    provided, where boost::multi_array is a template-class for multidimensional
    arrays.

    The supported operations are:
    \li Associative array-scalar operators: multiplication, plus and minus.
    \li Non-associative array-scalar operators: division, threshold.
    \li Array-array operators: multiplication, division, plus and minus.

    The following example demonstrates, how versatile the array-operators
    provided by mimas are:
    \include arrayop/main.cc

    @author Jan Wedekind <jan@wedesoft.de> 
    @date Mon Jun 13 17:13:05 UTC 2005
    @see imageOperators */
#include "mm_multi_array_op.tcc"

#endif
