//
// yet more classes! stuart meikle 
// Fri Jul  7 10:50:46 2000
//


#ifndef MM_OBJECT_INSTANCE_LIST_H
#define MM_OBJECT_INSTANCE_LIST_H

#include <boost/shared_ptr.hpp>
#include <list>
#include "mm_object.h"
#include "mm_coordinate_xform.h"

namespace mimas {
/** A little bit confusing.
    I wanted a means to have a single object type (such as for example a house
    object) which was then instanciated N times in different positions or
    situations. Hence this class. You can define an object, eg house and then
    use this class to point to the house structure and store alongside that
    all the inforamtion about each different instance. We use this in auto pgh
    to store the positions of all the different found instances of the house
    template. And, to add to the confusion, you can of course, store lists of
    lists. Its just a way to store a set of object instances so we can do
    things with them all , or so we can do repetitive ops on a given set of
    data. */
class	mm_object_instance_list : public mm_object
{
    //NB: because this is an object too we can have lists of lists!

    //this only really makes sense w.r.t. some other fixed co-ordinate system
    //eg the global gui co-ordinate system or something.
    private:
        mm_object_ptr o;
        mm_coordinate_xform_ptr_list locations;
    
    public:
	mm_object_instance_list(void)
	{
     // o=NULL;

	}
// 	~mm_object_instance_list(void)
// 	{
//        mm_coordinate_xform_ptr_list::iterator	it;
	
// 	    for(it = locations.begin(); it != locations.end(); it++)
// 	    {
// 		delete (*it);
		
// 		#ifdef MODS
//       cout << "@STU -> check that ~object_inst_list can delete lists of lists" << std::endl;
// 		#endif
// 	    }
// 	}
	
	void	setObject( mm_object_ptr ob ) { o=ob; }
	mm_object_ptr getObject(void)
		{ return o; }
	
	bool	empty(void)
		{ return locations.empty(); }
   mm_coordinate_xform_ptr_list&	getList(void) 
		{ return locations; }
	void	push_back( mm_coordinate_xform_ptr m )
		{ locations.push_back(m); }
};

typedef boost::shared_ptr< mm_object_instance_list > mm_object_instance_list_ptr;

}

#endif

