#ifndef MM_OPTICFLOW_DIFF_TOOL_H
#define MM_OPTICFLOW_DIFF_TOOL_H


#include "mm_config.h"
#include "mm_image_funcs.h"
#include "mm_image.h"
#include "mm_filter_grad.h"

#ifdef HAVE_LIBLAPACK

namespace mimas {
/**
 * Differential optic flow - see page 196-197 of Trucco and Verri
 * @author Bala Amavasai (bala@amavasai.org)
 * @date Mon Aug  5 11:54:14 UTC 2002
 * $Header: /cvs/mimas/include/mm_opticflow_diff_tool.h,v 1.10 2005/02/15 20:06:56 engjw Exp $
 */
class mm_opticflow_diff_tool
{

	private:
		int windowdist;
		mm_image<double> xflow,yflow;
		void smoothGaussian(mm_image<double>& imagein, double variance);
		double variance;

	public:
		mm_opticflow_diff_tool(void); ///< constructor
		~mm_opticflow_diff_tool(void); ///< destructor
		void findFlow(mm_image<int> &image_t, mm_image<int> &image_dt); ///< find the optic flow using input images taken at time t and at t+dt
		void findFlow(mm_image<double> &image_t, mm_image<double> &image_dt);
		void findFlow( std::vector< mm_image<double> > &imagein); ///< find the optic flow using input images taken at time t and at t+dt
		void getXflow(mm_image<double>& xf); ///< get the x direction vector flow
		void getYflow(mm_image<double>& yf); ///< get the y direction vector flow

};

}

#endif

#endif
