#ifndef MM_POL_MATCH_H
#define  MM_POL_MATCH_H

#include <boost/numeric/ublas/vector.hpp>
#include <boost/shared_ptr.hpp>
#include "mm_angle.h"
#include <list>

namespace mimas {
class mm_pol_model;
 
/**
 *
 * a simple structure used to store the found models in the scene
 * (the matches!)
 *
 * stumeikle Mon 04 Nov 2002 17:30:22 CET
 *
 * $Header: /cvs/mimas/include/mm_pol_match.h,v 1.7 2004/12/12 23:31:18 engjw Exp $
 */
class	mm_pol_match
{
    public:
   typedef boost::numeric::ublas::vector< double > Vector;
	mm_pol_model	*model_found;	///< is this used??
	Vector pos;		///< position of centroid of model
	mm_angle	orient;		///< orientation
	double		strength;	///< strength of match. higher==better match found
	double		scale;		///< the scale of the match.

    mm_pol_match()
    { model_found=NULL; strength=0; scale=1.0;}
    
    void	setPosition( const Vector &v )
		{ pos=v;}
    const Vector &getPosition() const
		{ return pos; }
    void	setOrientation( const mm_angle &a )
		{orient=a;}
    const mm_angle	&getOrientation() const
		{return orient;}
    void	setStrength(double d)
		{strength=d;}
    double	getScale(void) const
    		{ return scale; }
    void	setScale(double d)
    		{ scale=d; }

};

///
typedef boost::shared_ptr< mm_pol_match > mm_pol_match_ptr;

///
typedef std::list< mm_pol_match_ptr > mm_pol_match_ptr_list;

}

#endif
