#ifndef MM_POL_SCENE_H
#define MM_POL_SCENE_H

#include <boost/shared_ptr.hpp>
#include "mm_image.h"
#include "mm_pol_locator.h"
#include "mm_pol_model.h"

namespace mimas {
/**
 * Pairs of lines scene
 *
 * for now, organised as being distinct from the model class.
 * search for models in the scene.
 *
 *
 *
 * stumeikle Sun 27 Oct 2002 23:52:15 CET
 * $Header: /cvs/mimas/include/mm_pol_scene.h,v 1.9 2004/09/11 22:34:49 engjw Exp $
 *
 */
class mm_pol_scene : public mm_pol
{
private:
//    mm_image<int>		scene;
			        // maybe
    int				im_width,im_height;///< width and height of the image
      mm_pol_line_info_ptr_list	scene_line_info;   ///< the scene 'model' in pairs of lines

    void			makeEntries( mm_pol_model& m,mm_pol_locator& locate);


public:
    mm_pol_scene()
    {
	im_width=im_height=0;
    }
//     ~mm_pol_scene()
//     {
// 	mm_pol_line_info_ptr_list::iterator	i;
// 	for(i=scene_line_info.begin(); i!=scene_line_info.end(); ++i)
// 	{
// 	    delete (*i);
// 	}

// 	scene_line_info.clear();
//     }

    /**
    * create the scene representation from the image file given
    */
    void		createFromImageFile( const char *fn );
    /**
    * create the scene rep from the image given
    */
    void		createFromImage( mm_image<int> & im );
    /**
    * create the scene rep from the set of straight lines given
    */
    void 	createFromLines( mm_line_ptr_list &scene_lines, int , int );
    /**
    *
    * Find the given model in the scene and return a list of matches
    */
    mm_pol_match_ptr_list getMatches( mm_pol_model& m );

    mm_pol_match_ptr_list fastFind( mm_pol_model& m,mm_image<int>& im);
};

}
#endif

