//
// class image_prop
// stumeikle Sun May 12 20:43:47 2002
//
//

#ifndef MM_IMAGE_PROP_H
#define MM_IMAGE_PROP_H

#include <boost/shared_ptr.hpp>
#include "mm_image.h"
#include "mm_rgba.h"
#include "mm_object.h"

namespace mimas {
/**
 *
 * An mm_property_image is an image where every pixel is an mm_prop. this is the 
 * base class for those structures. contains type and draw interface.
 *
 * @author Stuart Meikle (stu@stumeikle.org)
 * @date Sun May 12 20:43:47 2002
 * $Header: /cvs/mimas/include/mm_prop.h,v 1.7 2004/12/14 23:27:07 engjw Exp $
 */
class mm_prop: public mm_object
{
    //baseclass of the image properties
    // a property associated with a point on an image
    public:
	typedef enum{ undefined, edgel, corner, edge_string } property_type;

    private:
	property_type	type;	 ///< value indicating the property type.
	mm_prop		*next; 	 ///< pointer to another property. we could have many props associated with each pixel

    protected:
	void	setPropertyType( property_type t ) { type = t; }

    public:
	mm_prop( property_type t ) { type = t; next=NULL; }

	virtual void draw( mm_image< mm_rgba< unsigned char > >& output,
                      int i, int j, bool c )
	{
	    // draw the property. this should always be overloaded. one time which is
	    // maybe isnt is during canny post processing:
     std::cout << "#FIX ME# PruneJuncs bug at pixel:" << i << "," << j
               << std::endl;
	}
};

typedef boost::shared_ptr< mm_prop > mm_prop_ptr;

}
#endif
