//
// mm_property_image
// 
// an image which contains pointers to structures which describe
// the underlying bitmap properties.
// 
//
// stumeikle Sun May 12 20:23:32 2002
//

#ifndef MM_PROPERTY_IMAGE_H
#define MM_PROPERTY_IMAGE_H

#include "mm_edge_string.h"
#include "mm_image_qtoutput.h"
#include "mm_prop.h"
#include "mm_image.h"
#include "mm_object.h"

namespace mimas {
  // class mm_edge_string_ptr_list;
  // class mm_edge_string;
  class mm_property_image : public mm_image< mm_prop_ptr >
{
    // an image of pointers to properties
//  private:
// 	bool	owns_props;
// 		//does this structure have responsibility for 
// 		//deleting the prop structures??

    protected:
	bool	draw_contrast;
		//should props be drawn so as to indicate their strengths?

    // we could override the display function and the read/write to file
    // functions here...
    public:
	mm_property_image(void)
	{
     // owns_props=true;
	    draw_contrast = false;
	}
	
	// ~mm_property_image(void);
	
	//overloaded functions from the base mm_image class
	//display needs to be changed now
	// void display(void);
  // void clear( void );
	
	//owernership if true means that pointed to structures will be 
	//deleted when this image is deleted
  // void setOwnership( bool b ) { owns_props = b; }
	void doDrawContrast() { draw_contrast = true; }
   bool getDrawContrast() const { return draw_contrast; }

	//a helpful visualisation tool...
	void addStrings( mm_edge_string_ptr_list& strings );
	void addStringsWithFilter( mm_edge_string_ptr_list& strings );

	void operator+=( mm_property_image& );

};


//handy macros
typedef mm_property_image mm_edge_image;
typedef mm_property_image mm_corner_image;
typedef mm_property_image mm_edgestring_image;

mm_image_qtoutput< mm_rgba< unsigned char > > &operator<<
  ( mm_image_qtoutput< mm_rgba< unsigned char > > &output,
    const mm_property_image &image );

}
#endif
