#ifndef __WARP_TCC
#define __WARP_TCC

namespace mimas {

template< class Tensor, typename T >
void mm_warp< Tensor, T >::warp( const mimas::mm_image<int> &in,
                                 mimas::mm_image<int> &out ) const
{
  int
    width = in.getWidth(),
    height = in.getHeight();
  double
    cx = 0.5 * width,
    cy = 0.5 * height;
  out.init( width, height );
  for ( int y=0; y<height; y++ )
    for ( int x=0; x<width; x++ ) {
      Vector v( 2 );
      v( 0 ) = x - cx;
      v( 1 ) = y - cy;
      Vector pos( t( v ) );
      int
        inx = x + (int)pos( 0 ),
        iny = y + (int)pos( 1 );
      if ( inx >= 0 && inx<width && iny>=0 && iny<height )
        out.pixel( x, y ) = in.pixel( inx, iny );
      else
        out.pixel( x, y ) = background;
    }
}

}

#endif
