//
// angle stuff
//

#include <cmath>
#include "mm_angle.h"

namespace mimas {

void 	mm_angle::arcTan2(double y, double x)
{
   if (y==0.0)
   {
      if (x>0.0)
      {
         angle= 0.0;
	 return;
      }
      if (x<0.0)
      {
         angle = -M_PI;
	 return;
      }
   }
   if (x==0.0)
   {
      if (y>0.0)
      {
         angle = M_PI/2.0;
	 return;
      }
      if (y<0.0)
      {
         angle = -M_PI/2.0;
	 return;
      }
   }

   angle = atan2(y,x);
}

mm_angle	mm_angle::operator+( mm_angle &a2 )
{
    mm_angle	retval;
    
    retval.angle= angle+a2.angle;
    retval.normalize();
    
    return retval;
}

/* mm_angle       mm_angle::operator+=( const mm_angle& right)
{
    mm_angle 	retval;
    
    retval.angle= angle + right.angle;
    retval.normalize();
    
    return retval;
}

mm_angle       mm_angle::operator+=( const double& right)
{
    mm_angle 	retval;
    
    retval.angle= angle + right;
    retval.normalize();
    
    return retval;
}*/

mm_angle&       mm_angle::operator+=( const mm_angle& right)
{
    angle= angle + right.angle;
    normalize();
    
    return *this;
}

mm_angle&       mm_angle::operator+=( const double& right)
{
    angle= angle + right;
    normalize();
    
    return *this;
}

mm_angle	mm_angle::operator-( mm_angle &a2 )
{
    mm_angle	retval;
    
    retval.angle= angle-a2.angle;
    retval.normalize();
    
    return retval;
}

void		mm_angle::normalize(void)
{
    while( angle <  -M_PI ) angle += (2.0*M_PI);
    while( angle >=  M_PI ) angle -= (2.0*M_PI);
}

}
