#include <cassert>
#include "mm_image_mesaoutput.h"
#include "mm_mesa_onscreen.h"

using namespace std;

namespace mimas {

// Thread-variable.
pthread_t staticThread;

template<>
void mm_image_mesaoutput< mm_rgba< unsigned char > >::repaint(void)
{
  // After a resize of the window the image-size may be temporarily wrong.
  if ( image.getWidth() == window->get_width() &&
       image.getHeight() == window->get_height() ) {
    mm_mesa_onscreen mesa( window );
    glPixelStorei( GL_UNPACK_ALIGNMENT, 1 );
    glRasterPos2i( -1, 1 );
    glPixelZoom( 1.0, -1.0 );
    // Direct access to image-memory!
    glDrawPixels( window->get_width(), window->get_height(),
                  GL_BGRA, GL_UNSIGNED_BYTE, image.rawData().data() );
  };
};

template<>
void mm_image_mesaoutput< unsigned char >::repaint(void)
{
  // After a resize of the window the image-size may be temporarily wrong.
  if ( image.getWidth() == window->get_width() &&
       image.getHeight() == window->get_height() ) {
    mm_mesa_onscreen mesa( window );
    glPixelStorei( GL_UNPACK_ALIGNMENT, 1 );
    glRasterPos2i( -1, 1 );
    glPixelZoom( 1.0, -1.0 );
    // Direct access to image-memory!
    glDrawPixels( window->get_width(), window->get_height(),
                  GL_LUMINANCE, GL_UNSIGNED_BYTE, image.rawData().data() );
  };
};

};
