//
// property image (pointer image) functions
//
// stumeikle Sun May 12 20:25:53 2002
//
// $Header: /cvs/mimas/lib/mm_property_image.cc,v 1.9 2004/12/12 23:31:19 engjw Exp $
//


#include "mm_edge_string.h"
#include "mm_property_image.h"

using namespace std;

namespace mimas {

// mm_property_image::~mm_property_image(void)
// {
//     //destroy all the created strutures
//     if (!initialised())
// 	return;
	
//     if (owns_props)
//     {
// 	//if the image is the only place where the 
// 	//properties are referenced, then delete them
//         int	x,y;
// 	for(y=0;y<getHeight();y++)
//         {
// 	    for(x=0;x<getWidth();x++)
// 	    {
// 		if (getPixel(x,y))
// 		    delete getPixel(x,y);
// 	    }
// 	}
//     }
// }

mm_image_qtoutput< mm_rgba< unsigned char > > &operator<<
  ( mm_image_qtoutput< mm_rgba< unsigned char > > &output,
    const mm_property_image &image )
{
    //display the properties with a mm_image<int>
    mm_image< mm_rgba< unsigned char > > temp;
    temp.init( image.getWidth(), image.getHeight() );
    
    int i,j;
    for(j=0;j<temp.getHeight();j++)
    {
	for(i=0;i<temp.getWidth();i++)
	{
       mm_prop_ptr p( image.pixel(i,j) );
		
	    if( p )
	    {
         p->draw( temp, i, j, image.getDrawContrast() );
	    }
	}
    }
	    
    //now display the image. repeating code here. naughty!
    output << temp;
    return output;
}



// void	mm_property_image::clear(void)
// {
//     if (!initialised())
// 	return;

//     if (owns_props)
//     {

//         int	x,y;
// 	for(y=0;y<getHeight();y++)
// 	{
// 	    for(x=0;x<getWidth();x++)
// 	    {
// 		if (getPixel(x,y))
// 		    delete getPixel(x,y);
// 	    }
// 	}
//     }
	    
//     //call the base function
//     mm_image<mm_prop*>::clear();
// }

void	mm_property_image::addStrings( mm_edge_string_ptr_list& edge_strings )
{
    //read the strings in and add to the image

    MMERROR( initialised(), mm_exception, ,
             "Can't add strings to an uninitialised image!" );
	
    mm_edge_string_ptr_list::iterator	sit;

    for(sit=edge_strings.begin();sit!=edge_strings.end();sit++)
    {
	mm_edge_string::iterator	esi;
	for(esi=(*sit)->begin();esi!=(*sit)->end();esi++)
	{
	    mm_string_el_ptr sel( *esi );
	    mm_edgel *edgel;
	    int			x,y;
		
	    edgel=sel->getEdgel();
	    x = (int)(edgel->getPosition()(0));
	    y = (int)(edgel->getPosition()(1));
	    if (getPixel(x,y)==0)
		setPixel( x,y, sel );
	}
    }
}


//
// WARNING: if you are going to add new operators here be Very careful
// 	    about which structure owns the pointed to props. usually
//	    these operations will only make sense if all vars are *not*
//	    owners.
//
void	mm_property_image::operator+=( mm_property_image& other)
{
    //other can own its data or not, makes no difference.
    //'this' must not own its data however.
    
    /* if ( this->owns_props )
    {
	mm->Error() << "Unable to perform += on an image which owns its own data. " << endl;
	mm->Error() << "Pls use setOwnership(false). " << endl;
	return;
   } */

    MMERROR( getWidth()==other.getWidth() && getHeight()==other.getHeight(),
             mm_exception, ,
             "Trying to add property images of different sizes, doing "
             "nothing." );
    
    int	x,y;
    for(y=0;y<getHeight();y++)
    {
	for(x=0;x<getWidth();++x)
	{
	    if (other.pixel(x,y) && !pixel(x,y))
	    {
         pixel(x,y) = other.pixel(x,y);
	    }
	}
    }
    
}
}
