#include "mm_timer.h"

namespace mimas {

double mm_timer::elapsed(void) const
{
  struct timeval actualTime;
  gettimeofday( &actualTime, NULL );

  // Use timersub-define, which does overflow-handling.
  struct timeval difference;
  timersub( &actualTime, &time, &difference );

  return difference.tv_sec + difference.tv_usec * 1.0E-6;
}

}
